Subject: Re: [RFC PATCH] Fix abnormal rcu dynticks_nesting values related to async page fault

From: "Paul E. McKenney" <[email-masked]>
Date: Tue, 27 Nov 2012 08:19:25 -0800

On Tue, Nov 27, 2012 at 04:56:30PM +0100, Frederic Weisbecker wrote:
> 2012/11/27 Gleb Natapov <[email-masked]>:
> > For KVM_PV_REASON_PAGE_NOT_PRESENT it behaves like an exception.
> 
> Ok.
> There seem to be a bug in kvm_async_pf_task_wait(). Using
> idle_cpu(cpu) to find out if the current task is the idle task may not
> work if there is pending wake up. Me may schedule another task but
> when that other task sleeps later we can't schedule back to idle until
> the fault is completed.
> 
> The right way is to use is_idle_task(current)

Agreed.  But if you instead need to figure out whether or not RCU believes
that the CPU is idle, use rcu_is_cpu_idle().  You need to figure out
whether or not RCU believes that the CPU is idle if you are trying to
play fast and loose with rcu_irq_enter() and rcu_irq_exit().

							Thanx, Paul